package cc.mrbird.febs.auth.service.impl;

import cc.mrbird.febs.auth.entity.SysUserOnline;
import cc.mrbird.febs.auth.service.ISysUserOnlineService;
import com.ruoyi.common.core.utils.StringUtils;
import com.ruoyi.system.api.model.LoginUser;
import org.springframework.stereotype.Service;

/**
 * 在线用户 服务层处理
 * 
 * @author ruoyi
 */
@Service
public class SysUserOnlineServiceImpl implements ISysUserOnlineService
{
    /**
     * 通过登录地址查询信息
     * 
     * @param ipaddr 登录地址
     * @param user 用户信息
     * @return 在线用户信息
     */
    @Override
    public SysUserOnline selectOnlineByIpaddr(String ipaddr, LoginUser user, String token)
    {
        if (StringUtils.equals(ipaddr, user.getSysUser().getLoginIp()))
        {
            return loginUserToUserOnline(user, token);
        }
        return null;
    }

    /**
     * 通过用户名称查询信息
     * 
     * @param userName 用户名称
     * @param user 用户信息
     * @return 在线用户信息
     */
    @Override
    public SysUserOnline selectOnlineByUserName(String userName, LoginUser user, String token)
    {
        if (StringUtils.equals(userName, user.getUsername()))
        {
            return loginUserToUserOnline(user, token);
        }
        return null;
    }

    /**
     * 通过登录地址/用户名称查询信息
     * 
     * @param ipaddr 登录地址
     * @param userName 用户名称
     * @param user 用户信息
     * @return 在线用户信息
     */
    @Override
    public SysUserOnline selectOnlineByInfo(String ipaddr, String userName, LoginUser user, String token)
    {
        if (StringUtils.equals(ipaddr, user.getSysUser().getLoginIp()) && StringUtils.equals(userName, user.getUsername()))
        {
            return loginUserToUserOnline(user, token);
        }
        return null;
    }

    /**
     * 设置在线用户信息
     * 
     * @param user 用户信息
     * @return 在线用户
     */
    @Override
    public SysUserOnline loginUserToUserOnline(LoginUser user, String token)
    {
        if (StringUtils.isNull(user))
        {
            return null;
        }
        SysUserOnline sysUserOnline = new SysUserOnline();
        sysUserOnline.setTokenId(token);
        sysUserOnline.setUserName(user.getUsername());
        sysUserOnline.setIpaddr(user.getSysUser().getLoginIp());
        sysUserOnline.setLoginTime(user.getLoginTime());
        return sysUserOnline;
    }
}
